{$mode objfpc}
{$m+}

unit graderhelperlib;
interface

type Data = record
	x : longint;
end;

function F(a, b : Data; op : longint) : Data;

procedure grader_main();

implementation

uses expr;

var
	rand_seed : longint;
	
	F_counter : longint;
	
	test_id : longint;
	n : longint;
	m : longint;
	k : longint;
	F_counter_limit : longint;
	
	mask1 : array[0..104] of dword;
	mask2 : array[0..104] of dword;
	
	a : array[0..20004] of Data;
	ops : array[0..20004] of longint;
	
	_id, _type, _pos, _new_op, _l, _r : array[0..20004] of longint;

procedure __exit();
begin
	close(input);
	close(output);
	halt;
end;

procedure WA();
begin
	writeln('-1');
end;

function getrand() : longint;
begin
	rand_seed := longint(int64(rand_seed) * 16807 mod 2147483647);
	exit(rand_seed);
end;

procedure init_rand_seed();
begin
	rand_seed := 31473487;
end;

function new_data() : Data;
var
	ret : Data;
begin
	ret.x := getrand();
	exit(ret);
end;

procedure init_masks();
var
	i, j : longint;
begin
	for i := 1 to k do begin
		for j := 0 to 31 do begin
			if ((getrand()>>17) and 1) = 1 then begin
				mask1[i] := mask1[i] or (1<<j);
			end else begin
				mask2[i] := mask2[i] or (1<<j);
			end;
		end;
	end;
end;

function _F(a, b : dword; op : longint) : dword;
begin
	exit((mask1[op] and ((mask1[op] and a)+(mask1[op] and b)))
		or (mask2[op] and ((mask2[op] and a) xor (mask2[op] and b))));
end;

function F(a, b : Data; op : longint) : Data;
var
	ret : Data;
begin
	if (op < 1) or (op > k) then begin
		WA();
		writeln('Invalid operation(op = ',op,')');
		__exit();
	end;
	inc(F_counter);
	if F_counter > F_counter_limit then begin
		WA();
		writeln('Too many calls of F()');
		__exit();
	end;
	ret.x := longint(_F(dword(a.x),dword(b.x),op));
	exit(ret);
end;

procedure grader_main();
var
	i : longint;
	checksum : longint;
	ret : Data;
	x : Data;
begin
	assign(input,'expr.in');
	assign(output,'expr.out');
	reset(input);
	rewrite(output);
	
	readln(test_id, n, m, k);
	readln(F_counter_limit);
	
	init_rand_seed();
	init_masks();
	
	for i := 0 to n - 1 do begin
		a[i] := new_data();
	end;
	
	for i := 1 to n - 1 do begin
		read(ops[i]);
	end;
	
	for i := 1 to m do begin
		read(_id[i]);
		read(_type[i]);
		
		if _type[i] = 1 then begin
			read(_pos[i]);
		end else if _type[i] = 2 then begin
			read(_pos[i],_new_op[i]);
		end else begin
			read(_l[i],_r[i]);
		end;
	end;
	
	init(test_id, n, m, k, a, ops);
	
	checksum := 0;
	
	for i := 1 to m do begin
		if _type[i] = 1 then begin
			x := new_data();
			ret := modify_data(_id[i], _pos[i], x);
		end else if _type[i] = 2 then begin
			ret := modify_op(_id[i], _pos[i], _new_op[i]);
		end else begin
			ret := reverse(_id[i], _l[i], _r[i]);
		end;
		checksum := longint((int64(checksum) * 998244353 + ret.x) mod 1000000009);
	end;
	
	if checksum < 0 then begin
		checksum := checksum + 1000000009;
	end;
	
	writeln(checksum);
	
	writeln(F_counter);
	
	__exit();
	
end;

end.
